' *****************************************************************************
'
' Copyright. 2008. Symvionics, Inc. All rights reserved.
'
' Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
' this source code and the accompanying documentation, if any, free of charge,
' provided that this paragraph, and the following two paragraphs appear in all
' copies and in all derivative works.  In no event shall this source code or
' this license thereto impact upon or fall within the scope of any other
' agreement that you have with Symvionics.
'
' BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
' BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
' CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
' SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
' YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
' ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
' BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
' USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
'
' SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
' PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
' HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR
' MAINTENANCE.
'
' ****************************************************************************

'Ignore all errors?? Only do this after debugging is complete... If at all..
'On error resume next

'Process the command line arguments for this script. 
'We need: 1) DataGroup

gTPCount = 1
dataGroup = "DG1"

Set Args = WScript.Arguments
If Args.Count > 0 Then dataGroup = Args(0)

If (Len(dataGroup) >  0) Then
	' Define an IADS Application Object so we can get data
	Set Iads = CreateObject("Iads.Application")
	Set TestPointLog = Iads.Logs.Item("TestPointLog")
	
	Set config = Iads.Configuration
	Set results = config.SqlQuery("select Parameters from DataGroups where Name = '" & dataGroup &"'")
	Dim paramTokens, logTokens
	
	If (results.Count > 0) Then
		' We should only get one result here (where DataGroup 'Name' field = what was specified)
		Set qr = results.Item(0)
		
		' And only one result here (the 'Parameters' field in the table)
		params = qr.Item(0)
		
		Dim delim (1)
		delim(0) = ","
		paramTokens = Tokenize(params, delim)
		
		' Define an Excel Application... The extra code here is to "attach" to the running instance of Excel if one exists..
		On error resume next
		Set Excel = GetObject( , "Excel.Application" )
		If TypeName(Excel) <> "Application" Then
		   Set Excel = CreateObject( "Excel.Application" )
		   Excel.Visible = True 'For Debugging purposes only
		End If
		on error Goto 0
		
		' Reference existing instance of Powerpoint, or create a new one
		On error resume next
		Set Powerpoint = GetObject( , "Powerpoint.Application" )
		If TypeName(Powerpoint) <> "Application" Then
		   Set Powerpoint = CreateObject( "Powerpoint.Application" )
		   Powerpoint.Visible = True 'For Debugging purposes only
		End If
		on error Goto 0
		
		Dim logDelim (1)
		logDelim(0) = "|"
		
		TPCount = TestPointLog.Count
		If TPCount > 0 Then
			For TPIndex = 1 To TPCount
				TPItem = TestPointLog.Item(TPIndex-1)				
				logTokens = Tokenize(TPItem, logDelim)
				
				' This If check skips empty rows in the Test Point Log
				If ((Trim(logTokens(6)) <> "") And (Trim(logTokens(7)) <> "")) Then					
					' Set up the start time
					Set strTime = CreateObject("IadsTime.IadsTime")
					strTime.TimeString = logTokens(6)
					
					' Set up the stop time
					Set stpTime = CreateObject("IadsTime.IadsTime")
					stpTime.TimeString = logTokens(7) 
					
					'MsgBox("Processing Summary Charts")
					' Plot each parameter
					If (results.Count > 0) Then
						  ProcessOneSummaryChart Excel, Powerpoint, paramTokens, strTime, stpTime
					End If
				End If
			Next
		End If
	
		' Clean up objects
		Set TestPointLog = Nothing
		Set results = Nothing
	Else ' If (results.Count > 0)
		MsgBox("No parameters defined in data group """ & dataGroup & """")
		'Iads.Quit()
	End If
	
	' Clean up objects
	Set Iads = Nothing
	Set TestPointLog = Nothing
Else ' If (Len(dataGroup) > 0)
	MsgBox("Aborting script - No data group defined!")
End If 
' Done!!

' Trim the end of a string, stopping at the first null character.
Function ConvertToVBScriptString( SomeString )
  Dim pos 'As Integer
  pos = InStr(1, SomeString, vbNullChar)
  If ( pos > 1 ) Then 
    ConvertToVBScriptString = Left(SomeString, pos - 1)
  ElseIf ( s = 0 ) Then
    ConvertToVBScriptString = SomeString
  Else 
    ConvertToVBScriptString = vbNullString
  End If
End Function

Function Tokenize(byVal TokenString, byRef TokenSeparators())

	Dim NumWords, a()
	NumWords = 0
	
	Dim NumSeps
	NumSeps = UBound(TokenSeparators)
	
	Do 
		Dim SepIndex, SepPosition
		SepPosition = 0
		SepIndex    = -1
		
		for i = 0 to NumSeps-1
		
			' Find location of separator in the string
			Dim pos
			pos = InStr(TokenString, TokenSeparators(i))
			
			' Is the separator present, and is it closest to the beginning of the string?
			If pos > 0 and ( (SepPosition = 0) or (pos < SepPosition) ) Then
				SepPosition = pos
				SepIndex    = i
			End If
			
		Next

		' Did we find any separators?	
		If SepIndex < 0 Then

			' None found - so the token is the remaining string
			redim preserve a(NumWords+1)
			a(NumWords) = TokenString
			
		Else

			' Found a token - pull out the substring		
			Dim substr
			substr = Trim(Left(TokenString, SepPosition-1))
	
			' Add the token to the list
			redim preserve a(NumWords+1)
			a(NumWords) = substr
		
			' Cutoff the token we just found
			Dim TrimPosition
			TrimPosition = SepPosition+Len(TokenSeparators(SepIndex))
			TokenString = Trim(Mid(TokenString, TrimPosition))
						
		End If	
		
		NumWords = NumWords + 1
	loop while (SepIndex >= 0)
	
	Tokenize = a
	
End Function

Sub ProcessOneSummaryChart( Excel, Powerpoint, parameterNames(), startTime, stopTime )

  ' Create an Iads Parameter, then create the an AdHoc Min,Max, and Rms derived parameter from this parameter
  On Error Resume Next
  
  ' Tell to Iads parameter to get all the data using the "MinMaxValue" function. This will allow us to 
  ' Plot the entire data set with our Excel chart using the smallest data possible, and *not* subsampling or 
  ' losing any visual information. Define the number of points to plot as the screen width * 2, thus each pixel will have two data points (one min, one max)
  'NumberOfPointsToPointInExcelColumn = screenWidth * 2  'Screen width times 2.. one for min, one for max
  NumberOfPoints = 2500  ' JFB: This is more than sufficient and works on any machine...screenWidth * 2
  
  ' Don't show Excel window to user. Change to FALSE afer debug finished
  Excel.Application.Visible = TRUE
  
  ' Set the number of new sheets in a new workbook
  Excel.Application.SheetsInNewWorkbook = 1
  
  ' Don't display any notices
  'Excel.Application.DisplayAlerts = FALSE
  
  'Make a new document
  On Error Resume Next
  Set workbook = Excel.ActiveWorkbook
  Set worksheet = Nothing
  If (TypeName(Workbook) <> "Workbook") Then
    Set workbook = Excel.Application.Workbooks.Add
    Set worksheet = workbook.Worksheets(1)
  End If
  On Error Goto 0
  
  
  ' Set print options margin measurements are in points
  Excel.ActiveSheet.PageSetup.LeftMargin = 18
  Excel.ActiveSheet.PageSetup.TopMargin = 36
  Excel.ActiveSheet.PageSetup.RightMargin = 18
  Excel.ActiveSheet.PageSetup.BottomMargin = 36
  
  ' Landscape Page Orientation
  Excel.ActiveSheet.PageSetup.Orientation = 2
  
  ' Create a new worksheet in the workbook
  On Error Resume Next
  If TypeName(worksheet) <> "Worksheet" Then
    Set worksheet = Excel.ActiveWorkbook.Worksheets.Add
  End If
  On Error Goto 0
  
  Dim parameter, parameterName
  For index=1 To UBound(parameterNames)
  	  parameterName = parameterNames(index-1)
	  Set parameter = Iads.Configuration.CreateParameter( parameterName )
	  If ( Err.Number = 0 ) Then
	  	  If (index = 1) Then
			  ' Set the column titles
			  worksheet.Name = "Test Point " & gTPCount'parameterName
			  worksheet.Range("A1").Value = "Time"
			  
			  ' Create a time column
			  Set st = CreateObject("IadsTime.IadsTime")
			  Set stp = CreateObject("IadsTime.IadsTime")
			  
			  'Copy the time from "StartTime"
			  st.SetTime(startTime)
			  stp.SetTime(stopTime)
			  
			  'Get the sample rate of the parameter so we can increment time by one data point (1/SampleRate)
			  SampleRate = parameter.SampleRate
			  
			  'Loop until we've created the entire column of time strings
			  'TimeIncr = parameter.GetNumDataPoints( startTime, stopTime ) / NumberOfPoints
			  NumberOfPoints = parameter.GetNumDataPoints( startTime, stopTime )
			  
			  If NumberOfPoints > 0 Then
			  	TimeIncr = (stp.TotalSeconds - st.TotalSeconds) / NumberOfPoints
			  Else
			  	TimeIncr = 0
			  End If
			  
			  Dim timeCol
			  ReDim timeCol(NumberOfPoints,1) 'as String
			  CurrentTime = CDbl(st.TotalSeconds)
			  NumPointMinusOne = NumberOfPoints - 1
			  For t = 0 To NumPointMinusOne
			  	'timeCol(t,0) = CDbl(st.TotalSeconds)
			  	timeCol(t,0) = CurrentTime
			  	CurrentTime = CurrentTime +TimeIncr
			  	st.AdvanceTime TimeIncr, SampleRate 
			  Next
			  worksheet.Range("A2:A" & NumberOfPoints).Value = timeCol
			  
			  Excel.Columns("A:A").EntireColumn.AutoFit
			  
			  ' Add a chart to Excel.... Arguments are Left, Top, Width, Height (That's a new one)
			  Set xlChart = Excel.Charts.Add
			  xlChart.HasTitle = True 
			  xlChart.ChartTitle.Characters.Text = "Summary Chart For Test Point " & gTPCount
			  xlChart.ChartTitle.Font.Size = 12 
			  xlChart.ChartType = xlLine 'xlXYScatterLines
			  xlChart.SizeWithWindow = True
			  xlChart.Axes(xlValue, xlPrimary).HasTitle = True 
			  xlChart.Axes(xlValue, xlPrimary).AxisTitle.Font.Size = 10 
			  xlChart.Axes(xlValue, xlPrimary).AxisTitle.Characters.Text = "Parameter Values for Datagroup """ & dataGroup & """"
			  xlChart.Axes(xlCategory, xlPrimary).HasTitle = True 
			  xlChart.Axes(xlCategory, xlPrimary).AxisTitle.Font.Size = 15 
			  xlChart.Axes(xlCategory, xlPrimary).AxisTitle.Characters.Text = "Elapsed Time (Secs)"
			  xlChart.Axes(xlCategory, xlPrimary).TickLabelPosition = xlTickLabelPositionLow
			  xlChart.Axes(xlCategory, xlPrimary).TickLabels.NumberFormat = "0.000"
			  
			  Set seriesTimeRange = worksheet.Range( "A2:A" & NumberOfPoints )

		  End If 

		  worksheet.Range(GetExcelColStr(index+1) & 1).Value = parameterName
		  
	  	  ' Put the data from the parameters into the worksheet
		  ProcessOneColumnOfData  worksheet, index+1, parameter, NumberOfPoints, startTime, st, stp
		  
		  ' Add an Excel "Series" for each column of data.. This allows you to plot multiple parameters on each plot
		  On Error Resume Next

		  ' Stupid Excel stuff...it defaults the first series to "Series 1" so make sure we change that
	      If ( index = 1 ) Then 
	        Set series = xlChart.SeriesCollection( index ) 
	      Else
	        Set series = xlChart.SeriesCollection.NewSeries
	      End If
	      
	      Set seriesRange = worksheet.Range( GetExcelColStr(index+1) & "2:" & GetExcelColStr(index+1) & NumberOfPoints )
	      series.Name = workSheet.Range( GetExcelColStr(index+1) & "1")
	      series.Values = seriesRange
	      series.XValues = seriesTimeRange
	      series.PlotOrder = 1
	      
	      workSheet.Range(GetExcelColStr(index+1) & ":" & GetExcelColStr(index+1)).EntireColumn.AutoFit

	  End If ' If (Err.Number == 0)
	  On Error Goto 0
  Next
			  
  ' Send the finished Chart to Powerpoint
  SendExcelChartToPowerpoint PowerPoint, xlChart, "Summary Chart For " & parameterName

  Set workbook = Nothing
  Set worksheet = Nothing
  Set xlChart = Nothing
  
  gTPCount = gTPCount+1

End Sub

Sub ProcessOneColumnOfData( worksheet, column, parameter, numberOfPoints, startTime, st, stp )

	If ( parameter Is Nothing ) Then Exit Sub

	' Tell the Iads parameter to return data that's compatible with VBScript
	parameter.VBScriptDataCompatibility = True
	
	' Tell the Iads parameter to summarize for the entire flight by using -1 for "values per summarization" argument (2nd)
	parameter.CurrentTime = startTime
	'Data = parameter.ValuesSummaryMinMax(numberOfPoints, -1)    'Get the data... Let Iads do all the visual summary work
	Data = parameter.ValuesInTimeRange(st, stp)

	' Excel's array's are transposed for setting columns of data (go figure)
	ExcelDataTransposed = TransposeIadsDataArray( Data )

	' Put the data into the Excel worksheet.... This should cause the Plot attached (if any) to update
	colName = GetExcelColStr(column)
	dataRange =  colName & "2:" & colName & numberOfPoints+2
	worksheet.Range(dataRange).Value = ExcelDataTransposed 

	' Free all the stuff we created
	Set parameter = Nothing
	 
End Sub

Sub SendExcelChartToPowerpoint( Powerpoint, ExcelChartToSend, ChartTitle )

  ' Make sure a chart is valid
  If ExcelChartToSend Is Nothing Then

    Exit Sub

  Else

    Powerpoint.Visible = True
    Const ppWindowMaximized = 3
    Const ppWindowMinimized = 2
    Const ppWindowNormal = 1
    'Powerpoint.Activate
    'Powerpoint.WindowState = ppWindowMaximized

    ' Could load a "template" here also..
    'Powerpoint.Presentations.Open FileNameOfPresentationTemplate
    'Set presentation = Powerpoint.ActivePresentation
    'Powerpoint.ActiveWindow.ViewType = ppViewSlide
   
    ' Add a new presentation    
    On Error Resume Next
    Set presentation = Powerpoint.ActivePresentation
    If ( TypeName(presentation) <> "Presentation" ) Then
      Set presentation = Powerpoint.Presentations.Add 
    End if
    on error Goto 0

    ' Reference the next available slide
    Set slide = presentation.Slides.Add( presentation.Slides.Count+1, ppLayoutBlank )
    slide.Select ' Select the slide we just added... If we don't do this the picture will go on the last slide
    'Worthless..slide.Name = "Hello"

    ' Copy ExcelChartToSend as a picture  XlPictureAppearance, XlCopyPictureFormat, XlPictureAppearance
    ExcelChartToSend.CopyPicture 'xlScreen, xlPicture, xlPrinter

    ' Paste Excel Chart 
    slide.Select 
    slide.Shapes.Paste
    slide.Shapes.SelectAll
    'slide.Shapes.AddTitle ChartTitle
    
    ' Fit Excel Chart in the slide
    FitPictureToSlidePowerpoint( Powerpoint )

    'presentation.Saved = True 

    ' Clean up
    Set slide = Nothing
    Set presentation = Nothing
  End If

End Sub

Sub FitPictureToSlidePowerpoint( Powerpoint )

    On Error Resume Next
    Set oPicture = Powerpoint.ActiveWindow.Selection.ShapeRange
    
    oPicture.LockAspectRatio = false 
    
    ' Get current picture width and height
    sPictureWidth = oPicture.Width
    sPictureHeight = oPicture.Height
    
    ' Get slide width and height
    sSlideWidth = Powerpoint.ActivePresentation.PageSetup.SlideWidth
    sSlideHeight = Powerpoint.ActivePresentation.PageSetup.SlideHeight
    
    ' Get scale factor that will fit picture to slide
    sScaleFactorW = sSlideWidth / sPictureWidth
    sScaleFactorH = sSlideHeight / sPictureHeight
    
    ' Make picture a little smaller than slide
    'sScaleFactorW = sScaleFactorW - 0.05
    'sScaleFactorH = sScaleFactorH - 0.05
    
    ' Resize picture
    oPicture.ScaleWidth CSng(sScaleFactorW), msoTrue
    oPicture.ScaleHeight CSng(sScaleFactorH), msoTrue
           
    ' Move the picture to the center of the slide, 
    ' and select it
    With Powerpoint.ActivePresentation.PageSetup
        oPicture.Left = (.SlideWidth \ 2) - (oPicture.Width \ 2)
        oPicture.Top = (.SlideHeight \ 2) - (oPicture.Height \ 2)
        oPicture.Select
    End With

    Powerpoint.ActiveWindow.Selection.ShapeRange.Align msoAlignCenters, True
    Powerpoint.ActiveWindow.Selection.ShapeRange.Align msoAlignMiddles, True

    On Error Goto 0
    
End Sub

'This function is a VB function to return the transpose of the input array. 
Public Function TransposeIadsDataArray(ByRef arrayIn) 

  intNRows = UBound(arrayIn, 1) - LBound(arrayIn, 1) + 1

  numDims = ArrayDims( arrayIn )
  If ( numDims > 1 ) Then
  	intNCols = UBound(arrayIn, 2) - LBound(arrayIn, 2) + 1
  Else
    intNCols = 1
  End If

  Dim arrayOut()
  ReDim arrayOut(intNRows, intNCols)  'VB is also "semi one based" on the arrays

  If ( intNCols > 1 ) Then
  
    intNRows = intNRows - 1
    intNCols = intNCols - 1
	  For intR = 0 To intNRows 
	    For intC = 0 To intNCols 
	      arrayOut(intC, intR) = arrayIn(intR, intC) 
	    Next  
	  Next  

  Else
  		
    ' Iads Arrays are Zero based
    intNRows = intNRows - 1
	  For intR = 0 To intNRows
        arrayOut(intR, 0) = arrayIn(intR) 
	  Next  

  End If  
  
  TransposeIadsDataArray = arrayOut 
  
End Function 

Public Function ArrayDims( someArray )  
   ArrayDims = 0 
   on error resume next 
   do while ( err = 0 ) 
      UBound someArray, ArrayDims
      ArrayDims = ArrayDims + 1 
   loop 
   on error goto 0 
End Function

''''''''''''''''''''''''''''''''''''''''''''''
' Excel utility functions

'Returns Excel column name from numeric position (e.g.: col_no 27 returns "AA")
'Example usage: sColName = xl_Col(7)
Function GetExcelColStr( Col_No ) 

  If Col_No < 1 Or Col_No > 256 Then Exit Function
  If Col_No < 27 Then                  'Single letter
    GetExcelColStr = Chr(Col_No + 64)
  Else                                 'Two letters
    GetExcelColStr = Chr(Int((Col_No - 1) / 26) + 64) & _
             		 Chr(((Col_No - 1) Mod 26) + 1 + 64)
  End If

End Function

'Returns an Excel column number from its name (e.g.: col_name "AA" returns  27)
'Example usage:
'iColNo = xl_ColName("Z")
Function GetExcelColNumber(Col_Name)

  Col_Name = UCase(Trim(Col_Name))
  Select Case Len(Col_Name)
  Case 1:     GetExcelColNumber = Asc(Col_Name) - 64
  Case 2:     xl_ColNo = ((Asc(Left(Col_Name, 1)) - 64) * 26) _
   	                     + (Asc(Right(Col_Name, 1)) - 64)
  End Select

End Function


' Excel chart type definitions
Const xlColumnClustered = 51
Const xlColumnStacked = 52
Const xlColumnStacked100 = 53
Const xl3DColumnClustered = 54
Const xl3DColumnStacked = 55
Const xl3DColumnStacked100 = 56
Const xlBarClustered = 57
Const xlBarStacked = 58
Const xlBarStacked100 = 59
Const xl3DBarClustered = 60
Const xl3DBarStacked = 61
Const xl3DBarStacked100 = 62
Const xlLineStacked = 63
Const xlLineStacked100 = 64
Const xlLineMarkers = 65
Const xlLineMarkersStacked = 66
Const xlLineMarkersStacked100 = 67
Const xlPieOfPie = 68
Const xlPieExploded = 69
Const xl3DPieExploded = 70
Const xlBarOfPie = 71
Const xlXYScatterSmooth = 72
Const xlXYScatterSmoothNoMarkers = 73
Const xlXYScatterLines = 74
Const xlXYScatterLinesNoMarkers = 75
Const xlAreaStacked = 76
Const xlAreaStacked100 = 77
Const xl3DAreaStacked = 78
Const xl3DAreaStacked100 = 79
Const xlDoughnutExploded = 80
Const xlRadarMarkers = 81
Const xlRadarFilled = 82
Const xlSurface = 83
Const xlSurfaceWireframe = 84
Const xlSurfaceTopView = 85
Const xlSurfaceTopViewWireframe = 86
Const xlBubble = 15
Const xlBubble3DEffect = 87
Const xlStockHLC = 88
Const xlStockOHLC = 89
Const xlStockVHLC = 90
Const xlStockVOHLC = 91
Const xlCylinderColClustered = 92
Const xlCylinderColStacked = 93
Const xlCylinderColStacked100 = 94
Const xlCylinderBarClustered = 95
Const xlCylinderBarStacked = 96
Const xlCylinderBarStacked100 = 97
Const xlCylinderCol = 98
Const xlConeColClustered = 99
Const xlConeColStacked = 100
Const xlConeColStacked100 = 101
Const xlConeBarClustered = 102
Const xlConeBarStacked = 103
Const xlConeBarStacked100 = 104
Const xlConeCol = 105
Const xlPyramidColClustered = 106
Const xlPyramidColStacked = 107
Const xlPyramidColStacked100 = 108
Const xlPyramidBarClustered = 109
Const xlPyramidBarStacked = 110
Const xlPyramidBarStacked100 = 111
Const xlPyramidCol = 112
Const xl3DColumn = &HFFFFeFFc
Const xlLine = 4
Const xl3DLine = &Hffffeffb
Const xl3DPie = &Hffffeffa
Const xlPie = 5
Const xlXYScatter = &Hffffefb7
Const xl3DArea = &Hffffeffe
Const xlArea = 1
Const xlDoughnut = &Hffffefe8
Const xlRadar = &Hffffefc9
Const xlRows = 1
Const xlColumns = 2
Const xlPrimary = 1
Const xlSecondary = 2
Const xlCategory = 1
Const xlSeriesAxis = 3
Const xlValue = 2
Const xlScreen = 1
Const xlText = -4158
Const xlBitmap = 2
Const xlPicture = -4147
Const xlMaximized = &Hffffefd7
Const xlMinimized = &Hffffefd4
Const xlNormal = &Hffffefd1
Const xlTickLabelPositionHigh = -4127
Const xlTickLabelPositionLow = -4134
Const xlTickLabelPositionNextToAxis = 4
Const xlTickLabelPositionNone = -4142


' Set a VBE reference to Microsoft Powerpoint Object Library
Const ppViewSlide = 1
Const ppViewSlideMaster = 2
Const ppViewSlideSorter = 7
Const ppViewTitleMaster = 8
Const msoAlignLefts = 0
Const msoAlignCenters = 1
Const msoAlignRights = 2
Const msoAlignTops = 3
Const msoAlignMiddles = 4
Const msoAlignBottoms = 5 
Const ppLayoutBlank = 12
Const ppLayoutChart = 8
Const ppLayoutChartAndText = 6
Const ppLayoutClipartAndText = 10
Const ppLayoutClipArtAndVerticalText = 26
Const ppLayoutFourObjects = 24
Const ppLayoutLargeObject = 15
Const ppLayoutMediaClipAndText = 18
Const ppLayoutMixed = -2
Const ppLayoutObject = 16
Const ppLayoutObjectAndText = 14
Const ppLayoutObjectOverText = 19
Const ppLayoutOrgchart = 7
Const ppLayoutTable = 4
Const ppLayoutText = 2
Const ppLayoutTextAndChart = 5
Const ppLayoutTextAndClipart = 9
Const ppLayoutTextAndMediaClip = 17
Const ppLayoutTextAndObject = 13
Const ppLayoutTextAndTwoObjects = 21
Const ppLayoutTextOverObject = 20
Const ppLayoutTitle = 1
Const ppLayoutTitleOnly = 11
Const ppLayoutTwoColumnText = 3
Const ppLayoutTwoObjectsAndText = 22
Const ppLayoutTwoObjectsOverText = 23
Const ppLayoutVerticalText = 25
Const ppLayoutVerticalTitleAndText = 27
Const ppLayoutVerticalTitleAndTextOverChart = 28


' Example plot Axis/Header/Legend setup
'=SERIES("Sales",Sheet1$A$2:$A$20,Sheet1!$B2:$B20,1)
'chart1.HasTitle = True 
'chart1.ChartTitle.Characters.Text = "BATS Temperature Profile" 
'chart1.ChartTitle.Font.Size = 12 
'chart1.Axes(xlCategory, xlPrimary).HasTitle = True 
'chart1.Axes(xlCategory, xlPrimary).AxisTitle.Font.Size = 10 
'chart1.Axes(xlCategory, xlPrimary).AxisTitle.FontStyle.Regular = True 
'chart1.Axes(xlCategory, xlPrimary).AxisTitle.Characters.Text = "Temperature (C)" 
'chart1.Axes(xlValue, xlPrimary).HasTitle = True 
'chart1.Axes(xlValue, xlPrimary).AxisTitle.Font.Size = 10 
'chart1.Axes(xlValue, xlPrimary).AxisTitle.Characters.Text = "Depth (meters)" 
'chart1.Axes(xlValue, xlPrimary).MinimumScaleIsAuto = True 
'chart1.Axes(xlValue, xlPrimary).MaximumScaleIsAuto = True 
'chart1.Axes(xlValue, xlPrimary).MinorUnitIsAuto = True 
'chart1.Axes(xlValue, xlPrimary).MajorUnitIsAuto = True 
'chart1.Axes(xlValue, xlPrimary).Crosses = xlAutomatic 
'chart1.Axes(xlValue, xlPrimary).ReversePlotOrder = True 
'chart1.Axes(xlValue, xlPrimary).ScaleType = xlLinear 
'chart1.HasLegend = False 
'chart1.PlotArea.Border.ColorIndex = 16 
'chart1.PlotArea.Border.Weight = xlThin 
'chart1.PlotArea.Border.LineStyle = xlContinuous 
'chart1.PlotArea.Fill.TwoColorGradientStyle = msoGradientHorizontal, Variant:=1 
'chart1.PlotArea.Fill.ForeColor.SchemeColor = 42  
'chart1.PlotArea.Fill.BackColor.SchemeColor = 13 
